input {
	beats {
		port => 5044
	}

	tcp {
		port => 5000
	}

	file {
		path => "/tmp/elk/spring.log"
  	}
}
## Add your filters / logstash plugins configuration here
## %{ts} %{+ts}  %{level} %{pid} --- [%{thread}] %{class->}: [%{uuid}] - [END] - [%{status}] - [%{method} %{uri}]
# 2021-04-20 10:26:29.825  INFO 1 --- [http-nio-8085-exec-3] c.g.q.t.ThemeEnabler$RequestInterceptor  : [fe7a225a-0c2d-49dc-b9b9-731139735def] - [START] - [GET /home] 
# 2021-04-20 10:32:26.994  WARN 1 --- [http-nio-8085-exec-1] .g.q.t.a.i.ThemeControllerImplementation : [6853f050-eaee-4b1a-8c4f-d60102ad4b0d] - [getHome] : someone get the home
filter {
	dissect {
		mapping => { "message" => "%{ts} %{+ts->} %{level} %{pid} --- [%{thread}] %{class->} %{msg}" }
		add_tag => [ "JAVA_LOG" ]
		tag_on_failure => []
	}
	dissect {
		mapping => { "msg" => ": [%{uuid}] - [END] - [%{status}] - [%{latency}] - [%{method} %{uri}]" }
		add_tag => [ "AFTER_REQUEST" ]
		tag_on_failure => []
		remove_field => ["msg"]
	}
	dissect {
		mapping => { "msg" => ": [%{uuid}] - [START] - [%{method} %{uri}]" }
		add_tag => [ "BEFORE_REQUEST" ]
		tag_on_failure => []
		remove_field => ["msg"]
	}
	dissect {
		mapping => { "msg" => ": [%{uuid}] - [%{function}] : %{msg}" }
		add_tag => [ "RUNTIME_LOG" ]
		tag_on_failure => []
	}
	mutate {
		convert => { "latency" => "integer"}
	}
	date {
		match => ["ts", "yyyy-MM-dd HH:mm:ss'.'SSS"]
		target => "@timestamp"
	}
}


output {
	elasticsearch {
		hosts => "elasticsearch:9200"
		user => "elastic"
		password => "changeme"
	}
    stdout { codec => rubydebug }
}